## This function is part of pinkanalyzer, by Jean-Luc Ohl

## wavfile = wavfile to analyze
## wavefilename = name of graph
## wavefilepath= output directory for graph files
## fext = extension for graph files


cd D:\Dropbox\prog\neobook\pinkanalyzer\\files\octave\;
wavfile1 = 'C:\Users\jlo\Desktop\pinks\pink-smpte48k.wav';
wavfilename1 = "pink-smpte48k.wav";
wavfilepath1 = 'C:\Users\jlo\Desktop\pinks\';
wavfile2 = 'C:\Users\jlo\Desktop\pinks\pink-smpte44k.wav';
wavfilename2 = "pink-smpte44k.wav";
wavfilepath2 = 'C:\Users\jlo\Desktop\pinks\';
wavfile3 = 'C:\Users\jlo\Desktop\pinks\REF DOLBY 85SPL (6).A1.wav';
wavfilename3 = "REF DOLBY 85SPL (6).A1.wav";
wavfilepath3 = 'C:\Users\jlo\Desktop\pinks\';
wavfile4 = 'C:\Users\jlo\Desktop\pinks\boucle-pink-20.wav';
wavfilename4 = "boucle-pink-20.wav";
wavfilepath4 = 'C:\Users\jlo\Desktop\pinks\';
wavfile5 = 'C:\Users\jlo\Desktop\pinks\test65.wav';
wavfilename5 = "test65.wav";
wavfilepath5 = 'C:\Users\jlo\Desktop\pinks\';
wavfile6 = 'C:\Users\jlo\Desktop\pinks\test96-65.wav';
wavfilename6 = "test96-65.wav";
wavfilepath6 = 'C:\Users\jlo\Desktop\pinks\';
wavfile7 = 'C:\Users\jlo\Desktop\pinks\Dolby-ref-A1.wav';
wavfilename7 = "Dolby-ref-A1.wav";
wavfilepath7 = 'C:\Users\jlo\Desktop\pinks\';
wavfile8 = 'C:\Users\jlo\Desktop\pinks\MNoise_MSPN_90_916_049_15.wav';
wavfilename8 = "MNoise_MSPN_90_916_049_15.wav";
wavfilepath8 = 'C:\Users\jlo\Desktop\pinks\';
file2 = 1;
file3 = 1;
file4 = 1;
file5 = 1;
file6 = 1;
file7 = 1;
file8 = 1;

fext = ".png";
fdevice = '-S1000,250';
smoothing = 0.1;
fullscale = 0;
wavfilename = "pink-smpte48k";
datetime = "08/03/2020 17:34:13";












##############################################################################	
	# Report the stage
	disp("Analysis starts...");
	fflush(stdout);	fflush(stderr);
	
	# max length for analysis in seconds
	maxlength = 300;

##############################################################################	
	# using octave 3.6 and above, you may need to uncomment graphics_toolkit gnuplot
	graphics_toolkit gnuplot
	#graphics_toolkit qt
	#graphics_toolkit fltk

	# Set axes and graph size
	set(0,'defaultaxesposition', [0.03, 0.07, 0.97, 0.83]);
	set(0, "defaultaxesfontname", "Arial"); 	
	set(0, "defaultaxesfontsize",9);
	# Set the default line width
	DLW = 4;
		
##############################################################################	
	# filter coeff for pink filter -3dB/oct
	D = [0.049922035 -0.095993537 0.050612699 -0.004408786];
	C = [1 -2.494956002   2.017265875  -0.522189400];	

	#a48=26; b48=35; c48=1;
	a48=0; b48=1; c48=0;
	a96=0; b96=1; c96=0; 

##############################################################################	
	# Open a new plot
	newplot(); 	clf(); figure(1,"visible","off");
	
	subplot(1,3,1:2); hold("on"); grid("on");
	axis([0.01, 22, -32, -12]);
	safetics("x",[0.02,0.04,0.07,0.1,0.15,0.2,0.3,0.4,0.6,0.8,1,1.5,2,3,4,6,8,10,15,20]); safetics("y",-32:2:-12);
	set( gca, 'LineWidth', 0.5, "gridlinestyle", ":")
	title("Pink noise analysis");	
	
	disp(" ");	
	[wav1,fs1] = wavread([wavfile1]);
	wav1L = wav1(:, 1);	
	n1 = min(rows(wav1L),maxlength*fs1);
	duration1 = n1/fs1
	wav1L = wav1L(1:n1);	
	RMS1 = 20 * log10(rms(wav1L))+fullscale	
	[irm1,ic1] = max(abs(wav1L));	
	irm1 = 20 * log10(irm1)+fullscale;
	crestf1 = irm1-RMS1
	wav1Lf = filter(C,D,wav1L); 	
	wav1log = 20*log10(ssev(wav1Lf,fs1,smoothing,1));	
	wav1log = wav1log.-mean(wav1log(1,floor(columns(wav1log)/400):floor(columns(wav1log)/20)))+ RMS1;	
	# reduction of nr of points for graphs : fs1/10 is enough, no reduction causes problems for gnuplot, ie 30s gives 1 440 000 points per file
	ixg1 = floor(logspace(1,log10(columns(wav1log)), fs1/10));
	semilogx(ixg1*fs1/(2000*n1), wav1log(ixg1), ["0;" ";"], "LineWidth",DLW);
	clear wavfile1 wav1 fs1 wav1L n1 duration1 ic1 wav1Lf wav1log corr1 ixg1;

	if (file2 == 1)	
	disp(" ");	
	[wav2,fs2] = wavread([wavfile2]);	
	wav2L = wav2(:, 1);
	n2 = min(rows(wav2L),maxlength*fs2);
	duration2 = n2/fs2
	wav2L = wav2L(1:n2);	
	RMS2 = 20 * log10(rms(wav2L))+fullscale		
	[irm2,ic2] = max(abs(wav2L));	
	irm2 = 20 * log10(irm2)+fullscale;
	crestf2 = irm2-RMS2
	wav2Lf = filter(C,D,wav2L); 	
	wav2log = 20*log10(ssev(wav2Lf,fs2,smoothing,1));
	wav2log = wav2log.-mean(wav2log(1,floor(columns(wav2log)/400):floor(columns(wav2log)/20)))+ RMS2;
	ixg2 = floor(logspace(1,log10(columns(wav2log)), fs2/10));
	semilogx(ixg2*fs2/(2000*n2), wav2log(ixg2), ["1;" ";"],"LineWidth",DLW);
	clear wavfile2 wav2 fs2 wav2L n2 duration2 ic2 wav2Lf wav2log corr2 ixg2;
	else
	endif
	
	if (file3 == 1)		
	disp(" ");
	[wav3,fs3] = wavread([wavfile3]);	
	wav3L = wav3(:, 1);
	n3 = min(rows(wav3L),maxlength*fs3);	
	duration3 = n3/fs3	
	wav3L = wav3L(1:n3);	
	RMS3 = 20 * log10(rms(wav3L))+fullscale		
	[irm3,ic3] = max(abs(wav3L));	
	irm3 = 20 * log10(irm3)+fullscale;
	crestf3 = irm3-RMS3
	wav3Lf = filter(C,D,wav3L); 	
	wav3log = 20*log10(ssev(wav3Lf,fs3,smoothing,1));
	wav3log = wav3log.-mean(wav3log(1,floor(columns(wav3log)/400):floor(columns(wav3log)/20)))+ RMS3;	
	ixg3 = floor(logspace(1,log10(columns(wav3log)), fs3/10));
	semilogx(ixg3*fs3/(2000*n3), wav3log(ixg3), ["2;" ";"],"LineWidth",DLW);
	clear wavfile3 wav3 fs3 wav3L n3 duration3 ic3 wav3Lf wav3log corr3 ixg3;
	else
	endif

	if (file4 == 1)		
	disp(" ");
	[wav4,fs4] = wavread([wavfile4]);	
	wav4L = wav4(:, 1);
	n4 = min(rows(wav4L),maxlength*fs4);	
	duration4 = n4/fs4
	wav4L = wav4L(1:n4);	
	RMS4 = 20 * log10(rms(wav4L))+fullscale		
	[irm4,ic4] = max(abs(wav4L));	
	irm4 = 20 * log10(irm4)+fullscale;
	crestf4 = irm4-RMS4
	wav4Lf = filter(C,D,wav4L); 	
	wav4log = 20*log10(ssev(wav4Lf,fs4,smoothing,1));
	wav4log = wav4log.-mean(wav4log(1,floor(columns(wav4log)/400):floor(columns(wav4log)/20)))+ RMS4;		
	ixg4 = floor(logspace(1,log10(columns(wav4log)), fs4/10));
	semilogx(ixg4*fs4/(2000*n4), wav4log(ixg4), ["3;" ";"],"LineWidth",DLW);
	clear wavfile4 wav4 fs4 wav4L n4 duration4 ic4 wav4Lf wav4log corr4 ixg4;
	else
	endif

	if (file5 == 1)			
	disp(" ");
	[wav5,fs5] = wavread([wavfile5]);
	wav5L = wav5(:, 1);	
	n5 = min(rows(wav5L),maxlength*fs5);
	duration5 = n5/fs5
	wav5L = wav5L(1:n5);	
	RMS5 = 20 * log10(rms(wav5L))+fullscale	
	[irm5,ic5] = max(abs(wav5L));	
	irm5 = 20 * log10(irm5)+fullscale;
	crestf5 = irm5-RMS5
	wav5Lf = filter(C,D,wav5L); 	
	wav5log = 20*log10(ssev(wav5Lf,fs5,smoothing,1));	
	wav5log = wav5log.-mean(wav5log(1,floor(columns(wav5log)/400):floor(columns(wav5log)/20)))+ RMS5;	
	ixg5 = floor(logspace(1,log10(columns(wav5log)), fs5/10));
	semilogx(ixg5*fs5/(2000*n5), wav5log(ixg5), ["4;" ";"],"LineWidth",DLW);
	clear wavfile5 wav5 fs5 wav5L n5 duration5 ic5 wav5Lf wav5log corr5 ixg5;
	else
	endif

	if (file6 == 1)			
	disp(" ");	
	[wav6,fs6] = wavread([wavfile6]);	
	wav6L = wav6(:, 1);
	n6 = min(rows(wav6L),maxlength*fs6);
	duration6 = n6/fs6
	wav6L = wav6L(1:n6);	
	RMS6 = 20 * log10(rms(wav6L))+fullscale		
	[irm6,ic6] = max(abs(wav6L));	
	irm6 = 20 * log10(irm6)+fullscale;
	crestf6 = irm6-RMS6
	wav6Lf = filter(C,D,wav6L); 	
	wav6log = 20*log10(ssev(wav6Lf,fs6,smoothing,1));
	wav6log = wav6log.-mean(wav6log(1,floor(columns(wav6log)/400):floor(columns(wav6log)/20)))+ RMS6;	
	ixg6 = floor(logspace(1,log10(columns(wav6log)), fs6/10));
	semilogx(ixg6*fs6/(2000*n6), wav6log(ixg6), ["5;" ";"],"LineWidth",DLW);
	clear wavfile6 wav6 fs6 wav6L n6 duration6 ic6 wav6Lf wav6log corr6 ixg6;
	else
	endif
	
	if (file7 == 1)			
	disp(" ");
	[wav7,fs7] = wavread([wavfile7]);	
	wav7L = wav7(:, 1);
	n7 = min(rows(wav7L),maxlength*fs7);
	duration7 = n7/fs7	
	wav7L = wav7L(1:n7);	
	RMS7 = 20 * log10(rms(wav7L))+fullscale		
	[irm7,ic7] = max(abs(wav7L));	
	irm7 = 20 * log10(irm7)+fullscale;
	crestf7 = irm7-RMS7
	wav7Lf = filter(C,D,wav7L); 	
	wav7log = 20*log10(ssev(wav7Lf,fs7,smoothing,1));
	wav7log = wav7log.-mean(wav7log(1,floor(columns(wav7log)/400):floor(columns(wav7log)/20)))+ RMS7;	
	ixg7 = floor(logspace(1,log10(columns(wav7log)), fs7/10));
	semilogx(ixg7*fs7/(2000*n7), wav7log(ixg7), [";" ";"],"LineWidth", DLW, "color", hsv2rgb([0.2, 1, 0.5]) );
	clear wavfile7 wav7 fs7 wav7L n7 duration7 ic7 wav7Lf wav7log corr7 ixg7;
	else
	endif

	if (file8 == 1)			
	disp(" ");
	[wav8,fs8] = wavread([wavfile8]);	
	wav8L = wav8(:, 1);
	n8 = min(rows(wav8L),maxlength*fs8);
	duration8 = n8/fs8	
	wav8L = wav8L(1:n8);	
	RMS8 = 20 * log10(rms(wav8L))+fullscale		
	[irm8,ic8] = max(abs(wav8L));	
	irm8 = 20 * log10(irm8)+fullscale;
	crestf8 = irm8-RMS8
	wav8Lf = filter(C,D,wav8L); 	
	wav8log = 20*log10(ssev(wav8Lf,fs8,smoothing,1));
	wav8log = wav8log.-mean(wav8log(1,floor(columns(wav8log)/400):floor(columns(wav8log)/20)))+ RMS8;		
	ixg8 = floor(logspace(1,log10(columns(wav8log)), fs8/10));
	semilogx(ixg8*fs8/(2000*n8), wav8log(ixg8), [";" ";"],"LineWidth",DLW, "color", hsv2rgb([0.7, 0.8, 0.6]) );
	clear wavfile8 wav8 fs8 wav8L n8 duration8 ic8 wav8Lf wav8log corr8 ixg8;
	else
	endif
	disp(" ");	hold("off");

	subplot(1,3,3); hold("on"); grid("off");
	axis([0, 10, 0, 10]); axis("off");
	text (-3, 9, [wavfilename1 "    RMS " num2str(RMS1,3) " dBFSD   max " num2str(irm1,3) " dBFSD   Crestf " num2str(crestf1,3) " dB"],'color', 'black',"fontsize",9);	
	if (file2 == 1)			
	text (-3, 8, [wavfilename2 "    RMS " num2str(RMS2,3) " dBFSD   max " num2str(irm2,3) " dBFSD   Crestf " num2str(crestf2,3) " dB"],'color', 'red',"fontsize",9);			
	else
	endif
	if (file3 == 1)		
	text (-3, 7, [wavfilename3 "    RMS " num2str(RMS3,3) " dBFSD   max " num2str(irm3,3) " dBFSD   Crestf " num2str(crestf3,3) " dB"],'color', 'green',"fontsize",9);		
	else
	endif
	if (file4 == 1)		
	text (-3, 6, [wavfilename4 "    RMS " num2str(RMS4,3) " dBFSD   max " num2str(irm4,3) " dBFSD   Crestf " num2str(crestf4,3) " dB"],'color', 'blue',"fontsize",9);		
	else
	endif	
	if (file5 == 1)		
	text (-3, 5, [wavfilename5 "    RMS " num2str(RMS5,3) " dBFSD   max " num2str(irm5,3) " dBFSD   Crestf " num2str(crestf5,3) " dB"],'color', 'magenta',"fontsize",9);		
	else
	endif
	if (file6 == 1)		
	text (-3, 4, [wavfilename6 "    RMS " num2str(RMS6,3) " dBFSD   max " num2str(irm6,3) " dBFSD   Crestf " num2str(crestf6,3) " dB"],'color', 'cyan', "fontsize",9);		
	else
	endif
	if (file7 == 1)		
	text (-3, 3, [wavfilename7 "    RMS " num2str(RMS7,3) " dBFSD   max " num2str(irm7,3) " dBFSD   Crestf " num2str(crestf7,3) " dB"],'color', hsv2rgb([0.2, 1, 0.5]),"fontsize",9);		
	else
	endif
	if (file8 == 1)		
	text (-3, 2, [wavfilename8 "    RMS " num2str(RMS8,3) " dBFSD   max " num2str(irm8,3) " dBFSD   Crestf " num2str(crestf8,3) " dB"],'color', hsv2rgb([0.7, 0.8, 0.6]),"fontsize",9);		
	else
	endif
	text (1, -0.4, [ datetime "         www.ohl.to"], 'color','black',"fontsize",9);			
	disp(" ");	hold("off");
	
	# Print to the output file
	print([wavfilepath1 wavfilename fext],fdevice);
	disp(" Cool, seems that the analysis is finished... ");	pause(2)
	fflush(stdout); fflush(stderr); clear all;